/*
* Code by Bodysoulspirit. Public Domain.
*/

#include "node.h"

VuoModuleMetadata({
	"title" : "Block Empty List Values",
	"description" : "Removes unpopulated values from the list and outputs the indexes of the populated and unpopulated values from the list.",
	"keywords" : [ "list", "non-empty", "nonempty" ],
	"version" : "1.0.1",
	"genericTypes" : {
		"VuoGenericType1" : {
			"compatibleTypes" : [
				"VuoAudioSamples",
				"VuoCursor",
				"VuoImage",
				"VuoLayer",
				"VuoSceneObject",
				"VuoShader",
				"VuoText",
			]
		}
	},
});

void nodeEvent(
	VuoInputData(VuoList_VuoGenericType1) values,
	VuoOutputData(VuoList_VuoGenericType1) populatedValues,
	VuoOutputData(VuoList_VuoInteger) populatedIndexes,
	VuoOutputData(VuoList_VuoInteger) unpopulatedIndexes
)
{
	*populatedValues = VuoListCreate_VuoGenericType1();
	*populatedIndexes = VuoListCreate_VuoInteger();
	*unpopulatedIndexes = VuoListCreate_VuoInteger();
	VuoGenericType1 data;

	for (unsigned long i = 1; i <= VuoListGetCount_VuoGenericType1(values); ++i)
	{
		data = VuoListGetValue_VuoGenericType1(values, i);
		if (VuoGenericType1_isPopulated(data))
		{
			VuoListAppendValue_VuoGenericType1(*populatedValues, data);
			VuoListAppendValue_VuoInteger(*populatedIndexes, i);
		}
		else
		{
			VuoListAppendValue_VuoInteger(*unpopulatedIndexes, i);
		}
	}
}
